# Automatic loading for AREP-Library
# MP, 12.03.98, converted to GAP v3.4.4
# SE, 21.01.98, as 'eplib.g' for EPLib
# SE, 22.07.98, AMatSparseMat, IdentityAMat added

PrintPkgInit(rec(name:="arep",version:="1.0",date:=[1998,7,22],
 copyright:=
   "(C) Sebastian Egner, Markus Pueschel -- Abstract REPresentations"));

# The exported symbols of the package AREP
# ========================================

AUTO( ReadPkg("arep", "lib/algogen"),
  MatrixDecompositionByPermPermSymmetry,
  MatrixDecompositionByMonMonSymmetry,
  MatrixDecompositionByPermIrredSymmetry
);

AUTO( ReadPkg("arep", "lib/amat"),
  AMatOps,
  IsAMat,
  IsInvertibleMat,
  IsIdentityMat,
  IdentityPermAMat,
  IdentityMonAMat,
  IdentityMatAMat,
  IdentityAMat,
  AllOneAMat,
  NullAMat,
  DiagonalAMat,
  DFTAMat,
  SORAMat,
  AMatPerm,
  AMatMon,
  AMatMat,
  ScalarMultipleAMat,
  PowerAMat,
  ConjugateAMat,
  DirectSumAMat,
  TensorProductAMat,
  GaloisConjugateAMat,
  InverseAMat,
  TransposedAMat,
  DeterminantAMat,
  TraceAMat,
  RankAMat,
  IsPermMat,
  IsMonMat,
  PermAMat,
  MonAMat,
  MatAMat,
  PermAMatAMat,
  MonAMatAMat,
  MatAMatAMat,
  SimplifyAMat,
  kbsAMat,
  SubmatrixAMat,
  kbsDecompositionAMat,
  LinearComplexityAMat,
  AMatSparseMat
);

AUTO( ReadPkg("arep", "lib/arep"),
  ARepOps,
  IsARep,
  TrivialPermARep,
  TrivialMonARep,
  TrivialMatARep,
  RegularARep,
  NaturalARep,
  ARepByImages,
  ARepByHom,
  ARepByCharacter,
  ConjugateARep,
  DirectSumARep,
  InnerTensorProductARep,
  OuterTensorProductARep,
  GaloisConjugateARep,
  RestrictionARep,
  InductionARep,
  ExtensionARep,
  GroupWithGenerators,
  ImageARep,
  IsEquivalentARep,
  CharacterARep,
  IsIrreducibleARep,
  KernelARep,
  IsFaithfulARep,
  ARepWithCharacter,
  GeneralFourierTransform,
  IsPermRep,
  IsMonRep,
  PermARepARep,
  MonARepARep,
  MatARepARep
);

AUTO( ReadPkg("arep", "lib/arepfcts"),
  IsRestrictedCharacter,
  AllExtendingCharacters,
  OneExtendingCharacter,
  IntertwiningSpaceARep,
  IntertwiningNumberARep,
  UnderlyingPermARep,
  IsTransitiveMonRep,
  IsPrimitiveMonRep,
  TransitivityDegreeMonRep,
  OrbitDecompositionMonRep,
  TransitiveToInductionMonRep,
  InsertedInductionARep,
  ConjugationPermLists,
  ConjugationPermReps,
  ConjugationTransitiveMonReps,
  TransversalChangeInductionARep,
  OuterTensorProductDecompositionMonRep,
  InnerConjugationARep,
  RestrictionInductionARep,
  AllMaximalNormalSubgroupsBetween,
  OneMaximalNormalSubgroupBetween,
  RestrictionToSubmoduleARep,
  kbsARep,
  kbsDecompositionARep,
  ExtensionOnedimensionalAbelianRep,
  DecompositionMonRep
);

AUTO( ReadPkg("arep", "lib/complex"),
  ImaginaryUnit,
  Conjugate,
  Re,
  Im,
  AbsSqr,
  Sqrt,
  ExpIPi,
  CosPi,
  SinPi,
  TanPi,
  ReducingRatFactorCyc,
  ReducingCycFactor
);

AUTO( ReadPkg("arep", "lib/mon"),
  IsMon,
  IsPermMon,
  IsDiagMon,
  MonOps,
  Mon,
  MatMon,
  MonMat,
  PermMon,
  DegreeMon,
  CharacteristicMon,
  OrderMon,
  TransposedMon,
  DeterminantMon,
  TraceMon,
  GaloisMon,
  DirectSumMon,
  DirectSumMon,
  TensorProductMon,
  TensorProductMon,
  CharPolyCyclesMon
);

AUTO( ReadPkg("arep", "lib/monmon"),
  MonMonSym,
  MonMonSymL,
  MonMonSymR
);

AUTO( ReadPkg("arep", "lib/permblk"),
  HasseEdgesList,
  BlockOfPartition,
  IsRefinedPartition,
  MeetPartition,
  JoinPartition,
  PartitionIndex,
  kbs,
  kbsM,
  LessPermBlockSym,
  CompletedPermBlockSym,
  DisplayPermBlockSym,
  PermBlockSymL,
  PermBlockSymR,
  PermBlockSymByPermutations,
  PermBlockSymBySubsets
);

AUTO( ReadPkg("arep", "lib/permmat"),
  PermMatSym,
  PermMatSymL,
  PermMatSymR,
  PermMatSymNormalL
);

AUTO( ReadPkg("arep", "lib/permperm"),
  PermPermSym,
  PermPermSymL,
  PermPermSymR
);

AUTO( ReadPkg("arep", "lib/summands"),
  DirectSummandsPermutedMat
);

AUTO( ReadPkg("arep", "lib/symmetry"),
  PermPermSymmetry,
  MonMonSymmetry,
  PermIrredSymmetry,
  PermIrredSymmetry1
);

AUTO( ReadPkg("arep", "lib/tools"),
  PartitionIndex,
  PartitionRefinement,
  DirectProductSymmetricGroups,
  TensorProductMat,
  MatPerm,
  PermMat,
  PermutedMat,
  DirectSumPerm,
  TensorProductPerm,
  PermOfCycleType,
  SupportVector,
  RowBlockStructureMat,
  ColumnBlockStructureMat,
  BlockStructureMat
);

AUTO( ReadPkg("arep", "lib/transf"),
  DiscreteFourierTransform,
  DiscreteFourierTransform,
  InverseDiscreteFourierTransform,
  InverseDiscreteFourierTransform,
  DiscreteHartleyTransform,
  InverseDiscreteHartleyTransform,
  DiscreteCosineTransform,
  InverseDiscreteCosineTransform,
  DiscreteSineTransform,
  InverseDiscreteSineTransform,
  DiscreteCosineTransformIV,
  InverseDiscreteCosineTransformIV,
  DiscreteSineTransformIV,
  InverseDiscreteSineTransformIV,
  DiscreteCosineTransformI,
  InverseDiscreteCosineTransformI,
  DiscreteSineTransformI,
  InverseDiscreteSineTransformI,
  WalshHadamardTransform,
  InverseWalshHadamardTransform,
  SlantTransform,
  InverseSlantTransform,
  HaarTransform,
  InverseHaarTransform,
  RationalizedHaarTransform,
  InverseRationalizedHaarTransform,
  DFT,
  InvDFT,
  DHT,
  InvDHT,
  DCT,
  InvDCT,
  DST,
  InvDST,
  DCT_IV,
  InvDCT_IV,
  DST_IV,
  InvDST_IV,
  DCT_I,
  InvDCT_I,
  DST_I,
  InvDST_I,
  WHT,
  InvWHT,
  ST,
  InvST,
  HT,
  InvHT,
  RHT,
  InvRHT
);
