#############################################################################
##
#A  upperbd2.g 		        GUAVA library                   Reinald Baart
#A                                                       & Jasper Cramwinckel
#A                                                          & Erik Roijackers
##
##  This file contains a reference and an upper bound on the minimum distance
##  of a linear code over GF(2) of given word length and dimension.
##
#H  @(#)$Id: upperbd2.g,v 1.2 1997/01/20 15:34:39 werner Exp $
##
#Y  Copyright (C)  1994,  Vakgroep Algemene Wiskunde,  T.U. Delft,  Nederland
##
#H  $Log: upperbd2.g,v $
#H  Revision 1.2  1997/01/20 15:34:39  werner
#H  Upgrade from Guava 1.2 to Guava 1.3 for GAP release 3.4.4.
#H
#H  Revision 1.1  1994/11/10  14:29:23  rbaart
#H  Initial revision
#H
##
GUAVA_TEMP_VAR := [ 
[ 12,  5,  4, "FP"],
[ 25,  8,  9, "YH1"],
[ 25, 15,  5, "Si"],
[ 26, 13,  7, "Pu2"],
[ 28,  6, 12, "BM"],
[ 28,  8, 11, "DM"],
[ 31,  7, 13, "vT3"],
[ 33,  9, 12, "He"],
[ 33, 12, 11, "HT"],
[ 34,  7, 15, "vT3"],
[ 35, 21,  7, "AEB"],
[ 37,  9, 15, "HT"],
[ 39, 28,  5, "HT"],
[ 40,  6, 18, "BM"],
[ 41, 12, 15, "HT"],
[ 42, 16, 13, "AEB"],
[ 43, 21, 11, "HT"],
[ 44,  8, 19, "DM"],
[ 45, 30,  7, "AEB"],
[ 46, 16, 15, "DK"],
[ 49, 12, 19, "HT"],
[ 52, 29, 11, "AEB"],
[ 53,  9, 23, "DEI"],
[ 55,  7, 25, "vT4"],
[ 56, 18, 19, "AEB"],
[ 58,  7, 27, "vT3"],
[ 58, 13, 23, "HT"],
[ 58, 16, 21, "AEB"],
[ 58, 42,  7, "AEB"],
[ 59, 39,  9, "AEB"],
[ 61,  7, 29, "Lv"],
[ 61,  9, 27, "DEI"],
[ 62, 16, 23, "AEB"],
[ 62, 51,  4, "Joplus"],
[ 63, 39, 11, "AEB"],
[ 65,  9, 29, "DEI"],
[ 65, 26, 19, "AEB"],
[ 66, 13, 27, "Das"],
[ 67,  8, 31, "DH"],
[ 68, 40, 13, "AEB"],
[ 69, 26, 21, "AEB"],
[ 70, 10, 31, "HT"],
[ 70, 38, 15, "AEB"],
[ 70, 50,  8, "Joplus"],
[ 72, 18, 27, "AEB"],
[ 72, 55,  7, "LP"],
[ 73, 15, 29, "AEB"],
[ 73, 26, 23, "AEB"],
[ 73, 37, 17, "AEB"],
[ 73, 48, 11, "LP"],
[ 74,  7, 35, "vT2"],
[ 74, 23, 25, "AEB"],
[ 74, 34, 19, "AEB"],
[ 75, 14, 31, "HT"],
[ 76, 47, 13, "LP"],
[ 77, 22, 27, "AEB"],
[ 77, 33, 21, "AEB"],
[ 78, 16, 31, "AEB"],
[ 79, 20, 29, "AEB"],
[ 79, 31, 23, "AEB"],
[ 80, 43, 17, "LP"],
[ 81, 48, 15, "LP"],
[ 82, 13, 35, "HT"],
[ 82, 30, 25, "AEB"],
[ 83,  8, 39, "DH"],
[ 83, 20, 31, "AEB"],
[ 83, 27, 27, "AEB"],
[ 83, 57, 11, "LP"],
[ 83, 62,  8, "Joplus"],
[ 84, 24, 29, "AEB"],
[ 84, 43, 19, "LP"],
[ 85, 40, 21, "AEB"],
[ 86,  7, 41, "vT2"],
[ 86, 10, 39, "HT"],
[ 86, 16, 35, "AEB"],
[ 86, 19, 33, "AEB"],
[ 86, 57, 12, "Joplus"],
[ 87, 38, 23, "AEB"],
[ 88, 24, 31, "AEB"],
[ 89,  7, 43, "vT2"],
[ 89, 15, 37, "AEB"],
[ 89, 36, 25, "AEB"],
[ 89, 55, 15, "LP"],
[ 90, 13, 39, "HT"],
[ 90, 19, 35, "LP"],
[ 90, 77,  5, "LP"],
[ 91,  8, 43, "DH"],
[ 91, 49, 19, "LP"],
[ 91, 53, 17, "Jo2"],
[ 91, 74,  6, "Joplus"],
[ 92, 24, 33, "AEB"],
[ 92, 31, 29, "AEB"],
[ 92, 35, 27, "AEB"],
[ 93, 15, 39, "AEB"],
[ 93, 18, 37, "AEB"],
[ 93, 21, 35, "AEB"],
[ 94, 10, 43, "DEI"],
[ 94, 13, 41, "DK"],
[ 94, 29, 31, "AEB"],
[ 95,  8, 45, "DH"],
[ 95, 49, 21, "LP"],
[ 96, 11, 43, "AEB"],
[ 96, 46, 23, "LP"],
[ 96, 69, 11, "LP"],
[ 97, 15, 41, "AEB"],
[ 97, 21, 37, "AEB"],
[ 97, 28, 33, "AEB"],
[ 97, 43, 25, "AEB"],
[ 97, 66, 13, "LP"],
[ 98,  8, 47, "DM"],
[ 98, 19, 39, "AEB"],
[ 98, 25, 35, "AEB"],
[ 98, 40, 27, "AEB"],
[ 98, 63, 15, "LP"],
[100,  9, 47, "AEB"],
[100, 17, 41, "AEB"],
[100, 34, 31, "AEB"],
[100, 77,  9, "LP"],
[101, 15, 43, "AEB"],
[101, 21, 39, "AEB"],
[101, 39, 29, "AEB"],
[101, 58, 19, "Jo2"],
[102, 10, 47, "DK"],
[102, 25, 37, "AEB"],
[102, 63, 17, "LP"],
[103, 33, 33, "AEB"],
[103, 56, 21, "LP"],
[104, 17, 43, "AEB"],
[104, 20, 41, "AEB"],
[104, 30, 35, "AEB"],
[105, 15, 45, "AEB"],
[105, 54, 23, "LP"],
[106, 13, 47, "AEB"],
[106, 25, 39, "AEB"],
[107, 16, 45, "AEB"],
[107, 48, 27, "LP"],
[107, 52, 25, "LP"],
[108, 20, 43, "AEB"],
[108, 30, 37, "AEB"],
[108, 45, 29, "LP"],
[108, 76, 13, "LP"],
[109, 15, 47, "AEB"],
[109, 24, 41, "AEB"],
[109, 38, 33, "AEB"],
[109, 42, 31, "AEB"],
[109, 73, 15, "LP"],
[110, 83, 10, "Joplus"],
[111, 16, 47, "AEB"],
[111, 29, 39, "AEB"],
[111, 63, 21, "LP"],
[112, 20, 45, "AEB"],
[112, 37, 35, "AEB"],
[112, 72, 17, "LP"],
[113, 12, 51, "AEB"],
[113, 15, 49, "AEB"],
[113, 24, 43, "AEB"],
[113, 27, 41, "AEB"],
[113, 34, 37, "AEB"],
[113, 69, 19, "Jo2"],
[114, 62, 23, "LP"],
[114, 96,  6, "Joplus"],
[115, 16, 49, "AEB"],
[115, 22, 45, "AEB"],
[115, 59, 25, "LP"],
[116,  9, 55, "DEI"],
[116, 20, 47, "AEB"],
[116, 26, 43, "AEB"],
[117, 12, 53, "AEB"],
[117, 34, 39, "AEB"],
[117, 57, 27, "LP"],
[118, 31, 41, "AEB"],
[118, 42, 35, "AEB"],
[118, 46, 33, "LP"],
[118, 50, 31, "LP"],
[118, 54, 29, "LP"],
[119,  8, 57, "DH"],
[119, 11, 55, "AEB"],
[119, 16, 51, "AEB"],
[119, 22, 47, "AEB"],
[119, 39, 37, "AEB"],
[119, 95,  9, "LP"],
[120, 20, 49, "AEB"],
[120, 26, 45, "AEB"],
[121, 12, 55, "AEB"],
[121, 72, 21, "LP"],
[121, 84, 15, "LP"],
[121, 88, 13, "LP"],
[122,  8, 59, "DH"],
[122, 18, 51, "AEB"],
[122, 21, 49, "AEB"],
[122, 31, 43, "AEB"],
[122, 69, 23, "LP"],
[122, 82, 16, "Joplus"],
[123, 16, 53, "AEB"],
[123, 39, 39, "AEB"],
[124,  9, 59, "AEB"],
[124, 26, 47, "AEB"],
[124, 36, 41, "AEB"],
[124, 79, 19, "LP"],
[125,  8, 61, "Lv"],
[125, 12, 57, "AEB"],
[125, 15, 55, "AEB"],
[125, 30, 45, "AEB"],
[125, 64, 27, "LP"],
[125, 68, 25, "LP"],
[126, 18, 53, "AEB"],
[126, 21, 51, "AEB"],
[126, 97, 11, "LP"],
[126,112,  5, "LP"],
[127, 11, 59, "AEB"],
[127, 16, 55, "AEB"],
[127, 25, 49, "AEB"],
[127, 35, 43, "AEB"],
[127, 50, 35, "LP"],
[127, 54, 33, "LP"],
[127, 62, 29, "LP"],
[129, 12, 59, "BK"],
[129, 15, 57, "BK"],
[129, 23, 51, "BK"],
[130, 18, 55, "BK"],
[130, 21, 53, "BK"],
[130, 27, 49, "BK"],
[130, 31, 47, "BK"],
[131, 16, 57, "BK"],
[132, 22, 53, "BK"],
[132, 91, 16, "Jo"],
[133, 12, 61, "BK"],
[133, 15, 59, "BK"],
[133, 96, 14, "Jo"],
[134, 18, 57, "BK"],
[134, 21, 55, "BK"],
[134, 27, 51, "BK"],
[135, 11, 63, "BK"],
[135, 16, 59, "BK"],
[135, 31, 49, "BK"],
[135, 90, 18, "Jo"],
[136, 22, 55, "BK"],
[136,103, 12, "Jo"],
[137, 12, 63, "BK"],
[137, 15, 61, "BK"],
[137, 17, 59, "BK"],
[137, 26, 53, "BK"],
[138,  8, 66, "Be"],
[138, 21, 57, "BK"],
[138, 89, 20, "Jo"],
[139, 16, 61, "BK"],
[139, 31, 51, "BK"],
[140, 22, 57, "BK"],
[140, 28, 53, "BK"],
[141, 15, 63, "BK"],
[141, 17, 61, "BK"],
[141, 26, 55, "BK"],
[141, 88, 22, "Jo"],
[141,117,  8, "Jo"],
[142, 21, 59, "BK"],
[143, 16, 63, "BK"],
[144, 22, 59, "BK"],
[144, 28, 55, "BK"],
[145, 12, 67, "BK"],
[145, 15, 65, "BK"],
[145, 17, 63, "BK"],
[145, 26, 57, "BK"],
[145, 99, 18, "Jo"],
[145,103, 16, "Jo"],
[145,116, 10, "Jo"],
[145,126,  6, "Jo"],
[146, 21, 61, "BK"],
[146, 23, 59, "BK"],
[146, 89, 24, "Jo"],
[147, 16, 65, "BK"],
[147, 18, 63, "BK"],
[147, 27, 57, "BK"],
[147, 97, 20, "Jo"],
[147,109, 14, "Jo"],
[148, 22, 61, "BK"],
[149, 12, 69, "BK"],
[149, 32, 55, "BK"],
[150, 23, 61, "BK"],
[150, 89, 26, "Jo"],
[150, 96, 22, "Jo"],
[151, 11, 71, "BK"],
[151, 16, 67, "BK"],
[151, 18, 65, "BK"],
[151, 27, 59, "BK"],
[152, 22, 63, "BK"],
[152,118, 12, "Jo"],
[153, 12, 71, "BK"],
[153, 15, 69, "BK"],
[153, 17, 67, "BK"],
[154, 23, 63, "BK"],
[154, 29, 59, "BK"],
[154, 86, 30, "Jo"],
[154, 96, 24, "Jo"],
[155, 13, 71, "BK"],
[155, 16, 69, "BK"],
[155, 18, 67, "BK"],
[155, 27, 61, "BK"],
[155, 33, 57, "BK"],
[155, 37, 55, "BK"],
[156, 22, 65, "BK"],
[156, 91, 28, "Jo"],
[157, 12, 73, "BK"],
[157, 17, 69, "BK"],
[157,110, 18, "Jo"],
[158, 23, 65, "BK"],
[158, 29, 61, "BK"],
[158,107, 20, "Jo"],
[158,115, 16, "Jo"],
[159, 11, 75, "BK"],
[159, 13, 73, "BK"],
[159, 16, 71, "BK"],
[159, 18, 69, "BK"],
[159, 27, 63, "BK"],
[159, 33, 59, "BK"],
[159, 97, 26, "Jo"],
[160,105, 22, "Jo"],
[161, 12, 75, "BK"],
[161, 92, 30, "Jo"],
[162,123, 14, "Jo"],
[163, 13, 75, "BK"],
[163, 97, 28, "Jo"],
[163,104, 24, "Jo"],
[165, 12, 77, "BK"],
[166,136, 10, "Jo"],
[167,104, 26, "Jo"],
[168, 98, 30, "Jo"],
[168,143,  8, "Jo"],
[169,117, 20, "Jo"],
[170,122, 18, "Jo"],
[171, 13, 79, "BK"],
[171, 16, 77, "BK"],
[171, 18, 75, "BK"],
[171, 21, 73, "BK"],
[171, 24, 71, "BK"],
[171,104, 28, "Jo"],
[171,115, 22, "Jo"],
[171,136, 12, "Jo"],
[172,128, 16, "Jo"],
[173, 12, 81, "BK"],
[173, 17, 77, "BK"],
[173, 19, 75, "BK"],
[173,113, 24, "Jo"],
[174, 23, 73, "BK"],
[174, 26, 71, "BK"],
[175, 13, 81, "BK"],
[175, 16, 79, "BK"],
[175, 18, 77, "BK"],
[175, 33, 67, "BK"],
[175, 39, 63, "BK"],
[175,101, 32, "sph"],
[176, 12, 83, "BK"],
[176, 24, 73, "BK"],
[176,105, 30, "Jo"],
[176,112, 26, "Jo"],
[177, 17, 79, "BK"],
[177, 19, 77, "BK"],
[177, 28, 71, "BK"],
[178,100, 34, "Jo"],
[178,138, 14, "Jo"],
[179, 13, 83, "BK"],
[179, 16, 81, "BK"],
[179, 18, 79, "BK"],
[179, 23, 75, "BK"],
[179, 29, 71, "BK"],
[180, 27, 73, "BK"],
[180,112, 28, "Jo"],
[180,166,  4, "Jo"],
[181, 17, 81, "BK"],
[181, 19, 79, "BK"],
[181, 22, 77, "BK"],
[181,106, 32, "Jo"],
[181,128, 20, "Jo"],
[182,125, 22, "Jo"],
[183, 13, 85, "BK"],
[183, 16, 83, "BK"],
[183, 18, 81, "BK"],
[183, 23, 77, "BK"],
[183,122, 24, "Jo"],
[183,134, 18, "Jo"],
[184, 99, 38, "Jo"],
[184,112, 30, "Jo"],
[184,164,  6, "Jo"],
[185, 12, 87, "BK"],
[185, 17, 83, "BK"],
[185, 19, 81, "BK"],
[185, 22, 79, "BK"],
[185, 24, 77, "BK"],
[186,107, 34, "Jo"],
[186,121, 26, "Jo"],
[187, 13, 87, "BK"],
[187, 16, 85, "BK"],
[187, 18, 83, "BK"],
[187, 23, 79, "BK"],
[187,142, 16, "Jo"],
[189, 12, 89, "BK"],
[189, 17, 85, "BK"],
[189, 19, 83, "BK"],
[189, 22, 81, "BK"],
[189, 24, 79, "BK"],
[189,113, 32, "Jo"],
[189,120, 28, "Jo"],
[190,104, 38, "Jo"],
[191, 13, 89, "BK"],
[192,109, 36, "Jo"],
[192,156, 12, "Jo"],
[192,161, 10, "Jo"],
[193, 12, 91, "BK"],
[193,113, 34, "Jo"],
[193,120, 30, "Jo"],
[193,131, 24, "Jo"],
[193,135, 22, "Jo"],
[194, 20, 85, "BK"],
[194, 25, 81, "BK"],
[194, 28, 79, "BK"],
[194,140, 20, "Jo"],
[195, 13, 91, "BK"],
[195, 16, 89, "BK"],
[195, 23, 83, "BK"],
[195, 32, 77, "BK"],
[196, 18, 87, "BK"],
[196, 29, 79, "BK"],
[196,109, 38, "Jo"],
[196,130, 26, "Jo"],
[197, 12, 93, "BK"],
[197, 17, 89, "BK"],
[197, 22, 85, "BK"],
[197, 24, 83, "BK"],
[197, 33, 77, "BK"],
[197,120, 32, "Jo"],
[197,147, 18, "Jo"],
[197,156, 14, "Jo"],
[198, 28, 81, "BK"],
[198,114, 36, "Jo"],
[198,128, 28, "Jo"],
[199, 13, 93, "BK"],
[199, 16, 91, "BK"],
[199, 23, 85, "BK"],
[199, 25, 83, "BK"],
[200, 18, 89, "BK"],
[200, 21, 87, "BK"],
[200, 29, 81, "BK"],
[200, 35, 77, "BK"],
[200,174,  8, "Jo"],
[201,  8, 98, "Be"],
[201, 12, 95, "BK"],
[201, 17, 91, "BK"],
[201, 24, 85, "BK"],
[201,120, 34, "Jo"],
[201,127, 30, "Jo"],
[202, 19, 89, "BK"],
[203, 13, 95, "BK"],
[203, 16, 93, "BK"],
[203, 23, 87, "BK"],
[203, 25, 85, "BK"],
[204, 18, 91, "BK"],
[204,116, 38, "Jo"],
[204,141, 24, "Jo"],
[204,158, 16, "Jo"],
[205, 14, 95, "BK"],
[205, 17, 93, "BK"],
[205, 24, 87, "BK"],
[205,146, 22, "Jo"],
[206, 19, 91, "BK"],
[206,121, 36, "Jo"],
[206,128, 32, "Jo"],
[206,139, 26, "Jo"],
[207, 13, 97, "BK"],
[207, 23, 89, "BK"],
[207, 25, 87, "BK"],
[207,136, 28, "Jo"],
[207,152, 20, "Jo"],
[208, 18, 93, "BK"],
[208, 29, 85, "BK"],
[208,113, 42, "Jo"],
[209, 14, 97, "BK"],
[209, 17, 95, "BK"],
[209,117, 40, "Jo"],
[209,127, 34, "Jo"],
[210, 19, 93, "BK"],
[210, 30, 85, "BK"],
[211, 13, 99, "BK"],
[211, 23, 91, "BK"],
[211, 25, 89, "BK"],
[211,122, 38, "Jo"],
[211,136, 30, "Jo"],
[212, 18, 95, "BK"],
[212, 29, 87, "BK"],
[213,162, 18, "Jo"],
[214, 11,103, "BK"],
[214,118, 42, "Jo"],
[214,128, 36, "Jo"],
[214,135, 32, "Jo"],
[215,178, 12, "Jo"],
[216, 17, 99, "BK"],
[216,123, 40, "Jo"],
[217, 12,103, "BK"],
[217, 14,101, "BK"],
[217, 24, 93, "BK"],
[217, 26, 91, "BK"],
[217,149, 26, "Jo"],
[217,153, 24, "Jo"],
[217,175, 14, "Jo"],
[218, 19, 97, "BK"],
[218, 22, 95, "BK"],
[218,128, 38, "Jo"],
[218,135, 34, "Jo"],
[218,146, 28, "Jo"],
[219, 25, 93, "BK"],
[219,159, 22, "Jo"],
[220, 13,103, "BK"],
[220, 18, 99, "BK"],
[220, 20, 97, "BK"],
[220, 31, 89, "BK"],
[220,144, 30, "Jo"],
[220,188, 10, "Jo"],
[221, 24, 95, "BK"],
[221, 26, 93, "BK"],
[222, 19, 99, "BK"],
[222,125, 42, "Jo"],
[222,135, 36, "Jo"],
[222,166, 20, "Jo"],
[222,175, 16, "Jo"],
[223,129, 40, "Jo"],
[224, 12,107, "BK"],
[224,144, 32, "Jo"],
[226,122, 46, "Jo"],
[226,142, 34, "Jo"],
[227,136, 38, "Jo"],
[229,131, 42, "Jo"],
[229,156, 28, "Jo"],
[229,160, 26, "Jo"],
[229,164, 24, "Jo"],
[230, 11,111, "BK"],
[230,178, 18, "Jo"],
[231, 13,109, "BK"],
[231, 16,107, "BK"],
[231,143, 36, "Jo"],
[231,154, 30, "Jo"],
[232, 18,105, "BK"],
[232, 20,103, "BK"],
[232, 23,101, "BK"],
[232,127, 46, "Jo"],
[232,137, 40, "Jo"],
[232,171, 22, "Jo"],
[232,211,  6, "Jo"],
[233, 12,111, "BK"],
[233, 17,107, "BK"],
[233,152, 32, "Jo"],
[234,132, 44, "Jo"],
[234,142, 38, "Jo"],
[236,137, 42, "Jo"],
[236,151, 34, "Jo"],
[237,210,  8, "Jo"],
[238,181, 20, "Jo"],
[239,143, 40, "Jo"],
[239,150, 36, "Jo"],
[240, 12,115, "BK"],
[240, 13,113, "BK"],
[240, 17,111, "BK"],
[240, 18,109, "BK"],
[240,134, 46, "Jo"],
[240,197, 14, "Jo"],
[241,138, 44, "Jo"],
[241,167, 28, "Jo"],
[241,171, 26, "Jo"],
[242,164, 30, "Jo"],
[242,204, 12, "Jo"],
[243,150, 38, "Jo"],
[243,161, 32, "Jo"],
[243,177, 24, "Jo"],
[243,195, 16, "Jo"],
[244,131, 50, "Jo"],
[244,144, 42, "Jo"],
[245, 12,117, "BK"],
[245, 14,115, "BK"],
[245, 17,113, "BK"],
[245, 19,111, "BK"],
[245, 21,109, "BK"],
[245,159, 34, "Jo"],
[246,139, 46, "Jo"],
[247,150, 40, "Jo"],
[247,185, 22, "Jo"],
[247,194, 18, "Jo"],
[248,144, 44, "Jo"],
[249,159, 36, "Jo"],
[250,  9,123, "BK"],
[250,136, 50, "Jo"],
[252,141, 48, "Jo"],
[252,151, 42, "Jo"],
[252,158, 38, "Jo"],
[252,173, 30, "Jo"],
[252,177, 28, "Jo"],
[253,145, 46, "Jo"],
[253,170, 32, "Jo"],
[254,183, 26, "Jo"],
[254,221, 10, "sph"],
[254,239,  4, "Jo"],
[255,197, 20, "Jo "]];
