#
#    The ANU Nilpotent Quotient Program (Version 1.1d, 18 May 1994)
#    Calculating a nilpotent quotient
#    Nilpotency class: 15
#
#    Calculating the abelian quotient ...
#    The abelian quotient has 3 generators
#        with the following exponents: 0 0 0
#
#    Calculating the class 2 quotient ...
#    Time spent on the integer matrix: 0 msec.
#    Maximal entry: 0
#    Layer 2 of the lower central series has 2 generators
#          with the following exponents: 0 0
#
#    Calculating the class 3 quotient ...
#    Time spent on the integer matrix: 0 msec.
#    Maximal entry: 0
#    Layer 3 of the lower central series has 1 generators
#          with the following exponents: 0
#
#    Calculating the class 4 quotient ...
#    Time spent on the integer matrix: 0 msec.
#    Maximal entry: 0
#    Layer 4 of the lower central series has 1 generators
#          with the following exponents: 2
#
#    Calculating the class 5 quotient ...
#    Time spent on the integer matrix: 0 msec.
#    Maximal entry: 1
#    Layer 5 of the lower central series has 2 generators
#          with the following exponents: 2 2
#
#    Calculating the class 6 quotient ...
#    Time spent on the integer matrix: 0 msec.
#    Maximal entry: 4
#    Layer 6 of the lower central series has 1 generators
#          with the following exponents: 2
#
#    Calculating the class 7 quotient ...
#    Time spent on the integer matrix: 0 msec.
#    Maximal entry: 4
#    Layer 7 of the lower central series has 1 generators
#          with the following exponents: 2
#
#    Calculating the class 8 quotient ...
#    Time spent on the integer matrix: 4 msec.
#    Maximal entry: 5
#    Layer 8 of the lower central series has 1 generators
#          with the following exponents: 2
#
#    Calculating the class 9 quotient ...
#    Time spent on the integer matrix: 0 msec.
#    Maximal entry: 4
#    Layer 9 of the lower central series has 1 generators
#          with the following exponents: 2
#
#    Calculating the class 10 quotient ...
#    Time spent on the integer matrix: 0 msec.
#    Maximal entry: 18
#    Layer 10 of the lower central series has 1 generators
#          with the following exponents: 2
#
#    Calculating the class 11 quotient ...
#    Time spent on the integer matrix: 0 msec.
#    Maximal entry: 11
#    Layer 11 of the lower central series has 1 generators
#          with the following exponents: 2
#
#    Calculating the class 12 quotient ...
#    Time spent on the integer matrix: 8 msec.
#    Maximal entry: 12
#    Layer 12 of the lower central series has 1 generators
#          with the following exponents: 2
#
#    Calculating the class 13 quotient ...
#    Time spent on the integer matrix: 4 msec.
#    Maximal entry: 15
#    Layer 13 of the lower central series has 1 generators
#          with the following exponents: 2
#
#    Calculating the class 14 quotient ...
#    Time spent on the integer matrix: 8 msec.
#    Maximal entry: 20
#    Layer 14 of the lower central series has 1 generators
#          with the following exponents: 2
#
#    Calculating the class 15 quotient ...
#    Time spent on the integer matrix: 8 msec.
#    Maximal entry: 30
#    Layer 15 of the lower central series has 1 generators
#          with the following exponents: 2
#


#    The epimorphism :
#    a|---> A
#    b|---> B
#    c|---> C


#    The nilpotent quotient :
    <A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S
      |
        G^2 = H*I*L,
        H^2 = K*L*M*N*O*P*Q*R*S,
        I^2 = K,
        J^2 = L,
        K^2 = M,
        L^2 = N,
        M^2 = O,
        N^2 = P,
        O^2 = Q,
        P^2 = R,
        Q^2 = S,
        R^2,
        S^2,
        B^A           =: B*D,
        B^(A^-1)      =  B*D^-1,
        C^A           =  C,
        C^(A^-1)      =  C,
        C^B           =: C*E,
        C^(B^-1)      =  C*E^-1,
        D^A           =  D,
        D^(A^-1)      =  D,
        D^B           =  D,
        D^(B^-1)      =  D,
        D^C           =  D*F^-1*G*J*L*N*P*R,
        D^(C^-1)      =  D*F*G*H*J*K,
        E^A           =: E*F,
        E^(A^-1)      =  E*F^-1*H,
        E^B           =  E,
        E^(B^-1)      =  E,
        E^C           =  E,
        E^(C^-1)      =  E,
        E^D           =  E*G*I*J*K*L*M*N*O*P*Q*R*S,
        E^(D^-1)      =  E*G*H,
        F^A           =  F*H*K*L,
        F^(A^-1)      =  F*H*K*L,
        F^B           =: F*G,
        F^(B^-1)      =  F*G*H*I*J,
        F^C           =  F,
        F^(C^-1)      =  F,
        F^D           =  F*H*K*L,
        F^(D^-1)      =  F*H*K*L,
        F^E           =  F*I*J,
        F^(E^-1)      =  F*I*J,
        G^A           =: G*H,
        G^(A^-1)      =  G*H,
        G^B           =  G*J*L*N*P*R,
        G^(B^-1)      =  G*J*L*N*P*R,
        G^C           =: G*I,
        G^(C^-1)      =  G*I,
        G^D           =  G*J*L*N*P*R,
        G^(D^-1)      =  G*J*L*N*P*R,
        G^E           =  G*J*L*N*P*R,
        G^(E^-1)      =  G*J*L*N*P*R,
        G^F           =  G,
        G^(F^-1)      =  G,
        H^A           =  H*K*L,
        H^(A^-1)      =  H*K*L,
        H^B           =  H*J,
        H^(B^-1)      =  H*J,
        H^C           =  H,
        H^(C^-1)      =  H,
        H^D           =  H*K*L,
        H^(D^-1)      =  H*K*L,
        H^E           =  H*K*L,
        H^(E^-1)      =  H*K*L,
        H^F           =  H,
        H^(F^-1)      =  H,
        H^G           =  H,
        I^A           =  I,
        I^(A^-1)      =  I,
        I^B           =: I*J,
        I^(B^-1)      =  I*J,
        I^C           =  I*K*M*O*Q*S,
        I^(C^-1)      =  I*K*M*O*Q*S,
        I^D           =  I*K*M*O*Q*S,
        I^(D^-1)      =  I*K*M*O*Q*S,
        I^E           =  I*K*M*O*Q*S,
        I^(E^-1)      =  I*K*M*O*Q*S,
        I^F           =  I,
        I^(F^-1)      =  I,
        I^G           =  I,
        I^H           =  I,
        J^A           =  J*K*L*M*N*O*P*Q*R*S,
        J^(A^-1)      =  J*K*L*M*N*O*P*Q*R*S,
        J^B           =  J*L*N*P*R,
        J^(B^-1)      =  J*L*N*P*R,
        J^C           =: J*K,
        J^(C^-1)      =  J*K,
        J^D           =  J*L*N*P*R,
        J^(D^-1)      =  J*L*N*P*R,
        J^E           =  J*L*N*P*R,
        J^(E^-1)      =  J*L*N*P*R,
        J^F           =  J,
        J^(F^-1)      =  J,
        J^G           =  J,
        J^H           =  J,
        J^I           =  J,
        K^A           =  K,
        K^(A^-1)      =  K,
        K^B           =: K*L,
        K^(B^-1)      =  K*L,
        K^C           =  K*M*O*Q*S,
        K^(C^-1)      =  K*M*O*Q*S,
        K^D           =  K*M*O*Q*S,
        K^(D^-1)      =  K*M*O*Q*S,
        K^E           =  K*M*O*Q*S,
        K^(E^-1)      =  K*M*O*Q*S,
        K^F           =  K,
        K^(F^-1)      =  K,
        K^G           =  K,
        K^H           =  K,
        K^I           =  K,
        K^J           =  K,
        L^A           =  L*M*N*O*P*Q*R*S,
        L^(A^-1)      =  L*M*N*O*P*Q*R*S,
        L^B           =  L*N*P*R,
        L^(B^-1)      =  L*N*P*R,
        L^C           =: L*M,
        L^(C^-1)      =  L*M,
        L^D           =  L*N*P*R,
        L^(D^-1)      =  L*N*P*R,
        L^E           =  L*N*P*R,
        L^(E^-1)      =  L*N*P*R,
        L^F           =  L,
        L^(F^-1)      =  L,
        L^G           =  L,
        L^H           =  L,
        L^I           =  L,
        L^J           =  L,
        L^K           =  L,
        M^A           =  M,
        M^(A^-1)      =  M,
        M^B           =: M*N,
        M^(B^-1)      =  M*N,
        M^C           =  M*O*Q*S,
        M^(C^-1)      =  M*O*Q*S,
        M^D           =  M*O*Q*S,
        M^(D^-1)      =  M*O*Q*S,
        M^E           =  M*O*Q*S,
        M^(E^-1)      =  M*O*Q*S,
        M^F           =  M,
        M^(F^-1)      =  M,
        M^G           =  M,
        M^H           =  M,
        M^I           =  M,
        M^J           =  M,
        N^A           =  N*O*P*Q*R*S,
        N^(A^-1)      =  N*O*P*Q*R*S,
        N^B           =  N*P*R,
        N^(B^-1)      =  N*P*R,
        N^C           =: N*O,
        N^(C^-1)      =  N*O,
        N^D           =  N*P*R,
        N^(D^-1)      =  N*P*R,
        N^E           =  N*P*R,
        N^(E^-1)      =  N*P*R,
        N^F           =  N,
        N^(F^-1)      =  N,
        N^G           =  N,
        N^H           =  N,
        N^I           =  N,
        O^A           =  O,
        O^(A^-1)      =  O,
        O^B           =: O*P,
        O^(B^-1)      =  O*P,
        O^C           =  O*Q*S,
        O^(C^-1)      =  O*Q*S,
        O^D           =  O*Q*S,
        O^(D^-1)      =  O*Q*S,
        O^E           =  O*Q*S,
        O^(E^-1)      =  O*Q*S,
        O^F           =  O,
        O^(F^-1)      =  O,
        O^G           =  O,
        P^A           =  P*Q*R*S,
        P^(A^-1)      =  P*Q*R*S,
        P^B           =  P*R,
        P^(B^-1)      =  P*R,
        P^C           =: P*Q,
        P^(C^-1)      =  P*Q,
        P^D           =  P*R,
        P^(D^-1)      =  P*R,
        P^E           =  P*R,
        P^(E^-1)      =  P*R,
        P^F           =  P,
        P^(F^-1)      =  P,
        Q^A           =  Q,
        Q^(A^-1)      =  Q,
        Q^B           =: Q*R,
        Q^(B^-1)      =  Q*R,
        Q^C           =  Q*S,
        Q^(C^-1)      =  Q*S,
        Q^D           =  Q*S,
        Q^(D^-1)      =  Q*S,
        Q^E           =  Q*S,
        Q^(E^-1)      =  Q*S,
        R^A           =  R*S,
        R^(A^-1)      =  R*S,
        R^B           =  R,
        R^(B^-1)      =  R,
        R^C           =: R*S,
        R^(C^-1)      =  R*S >

#    Class : 15
#    Nr of generators of each class : 3 2 1 1 2 1 1 1 1 1 1 1 1 1 1

