#
#    The ANU Nilpotent Quotient Program (Version 1.1d, 18 May 1994)
#    Calculating a nilpotent quotient
#    Nilpotency class: 8
#
#    Calculating the abelian quotient ...
#    The abelian quotient has 4 generators
#        with the following exponents: 0 0 0 0
#
#    Calculating the class 2 quotient ...
#    Time spent on the integer matrix: 0 msec.
#    Maximal entry: 0
#    Layer 2 of the lower central series has 3 generators
#          with the following exponents: 0 0 0
#
#    Calculating the class 3 quotient ...
#    Time spent on the integer matrix: 0 msec.
#    Maximal entry: 0
#    Layer 3 of the lower central series has 3 generators
#          with the following exponents: 0 0 0
#
#    Calculating the class 4 quotient ...
#    Time spent on the integer matrix: 0 msec.
#    Maximal entry: 0
#    Layer 4 of the lower central series has 3 generators
#          with the following exponents: 0 0 0
#
#    Calculating the class 5 quotient ...
#    Time spent on the integer matrix: 0 msec.
#    Maximal entry: 2
#    Layer 5 of the lower central series has 4 generators
#          with the following exponents: 0 2 3 0
#
#    Calculating the class 6 quotient ...
#    Time spent on the integer matrix: 0 msec.
#    Maximal entry: 6
#    Layer 6 of the lower central series has 6 generators
#          with the following exponents: 2 2 3 3 0 6
#
#    Calculating the class 7 quotient ...
#    Time spent on the integer matrix: 4 msec.
#    Maximal entry: 14
#    Layer 7 of the lower central series has 9 generators
#          with the following exponents: 2 2 2 3 3 6 2 3 6
#
#    Calculating the class 8 quotient ...
#    Time spent on the integer matrix: 12 msec.
#    Maximal entry: 36
#    Layer 8 of the lower central series has 13 generators
#          with the following exponents: 2 2 2 2 3 3 3 2 2 3 3 6 2
#


#    The epimorphism :
#    a|---> A
#    b|---> B
#    c|---> C
#    d|---> D


#    The nilpotent quotient :
    <A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z,A1,B1,C1,D1,E1,F1,G1,H1,I1,J1,K1,L1,M1,N1,O1,P1,Q1,R1,S1
      |
        O^2 = U,
        P^3 = W^3*D1*F1^5,
        R^2 = A1^2*K1^2*N1,
        S^2 = B1,
        T^3 = C1^3*R1^5,
        U^3 = D1,
        W^6 = S1,
        X^2 = K1^2,
        Y^2 = L1^2,
        Z^2,
        A1^3,
        B1^3 = O1,
        C1^6,
        D1^2,
        E1^3 = S1,
        F1^6,
        G1^2,
        H1^2,
        I1^2,
        J1^2,
        K1^3,
        L1^3,
        M1^3,
        N1^2,
        O1^2,
        P1^3,
        Q1^3,
        R1^6,
        S1^2,
        B^A           =: B*E,
        B^(A^-1)      =  B*E^-1,
        C^A           =  C,
        C^(A^-1)      =  C,
        C^B           =: C*F,
        C^(B^-1)      =  C*F^-1,
        D^A           =  D,
        D^(A^-1)      =  D,
        D^B           =  D,
        D^(B^-1)      =  D,
        D^C           =: D*G,
        D^(C^-1)      =  D*G^-1,
        E^A           =  E,
        E^(A^-1)      =  E,
        E^B           =  E,
        E^(B^-1)      =  E,
        E^C           =  E*H^-1,
        E^(C^-1)      =  E*H*K^-1,
        E^D           =  E,
        E^(D^-1)      =  E,
        F^A           =: F*H,
        F^(A^-1)      =  F*H^-1,
        F^B           =  F,
        F^(B^-1)      =  F,
        F^C           =: F*I,
        F^(C^-1)      =  F*I^-1,
        F^D           =  F*J^-1*M^-1*O*Q^-1*S*U^2*Z*B1^2*J1*Q1,
        F^(D^-1)      =  F*J*M*O*S*Z*J1,
        F^E           =  F,
        F^(E^-1)      =  F,
        G^A           =  G,
        G^(A^-1)      =  G,
        G^B           =: G*J,
        G^(B^-1)      =  G*J^-1*O*U^2*Z*D1,
        G^C           =  G,
        G^(C^-1)      =  G,
        G^D           =  G,
        G^(D^-1)      =  G,
        G^E           =  G*L*R*I1,
        G^(E^-1)      =  G*L^-1*R*X*A1*I1*K1^2*N1,
        G^F           =  G*M^-1*O*S*U^2*Z*B1^2*D1*J1*O1,
        G^(F^-1)      =  G*M*O*U^2*Z*D1,
        H^A           =  H,
        H^(A^-1)      =  H,
        H^B           =  H,
        H^(B^-1)      =  H,
        H^C           =  H*K,
        H^(C^-1)      =  H*K^-1,
        H^D           =  H*L^-1*N^-1*R*V^-1*X*Y*A1*G1*I1*K1^2*L1,
        H^(D^-1)      =  H*L*N*R*X*Y*G1*H1*I1*N1,
        H^E           =  H,
        H^(E^-1)      =  H,
        H^F           =  H,
        H^(F^-1)      =  H,
        H^G           =  H*N*X*Y*G1*H1*N1,
        H^(G^-1)      =  H*N^-1*X*Y*C1^5*G1*H1*K1*L1*N1*P1,
        I^A           =: I*K,
        I^(A^-1)      =  I*K^-1,
        I^B           =  I,
        I^(B^-1)      =  I,
        I^C           =  I,
        I^(C^-1)      =  I,
        I^D           =  I*M^-2*O*P*Q^-1*S*U*M1^2*Q1,
        I^(D^-1)      =  I*M^2*O*P^2*Q^-1*S*U*W^5*B1^2*D1*F1*M1*Q1,
        I^E           =  I,
        I^(E^-1)      =  I,
        I^F           =  I,
        I^(F^-1)      =  I,
        I^G           =  I*P*S*B1*M1^2*O1,
        I^(G^-1)      =  I*P^2*S*W^3*B1*D1*E1^2*F1*M1*O1,
        I^H           =  I,
        I^(H^-1)      =  I,
        J^A           =: J*L,
        J^(A^-1)      =  J*L^-1*X*K1,
        J^B           =  J*O*U^2*D1,
        J^(B^-1)      =  J*O*Z,
        J^C           =: J*M,
        J^(C^-1)      =  J*M^-1*P*O1,
        J^D           =  J,
        J^(D^-1)      =  J,
        J^E           =  J*R*A1*H1*I1*K1,
        J^(E^-1)      =  J*R*H1*I1*N1,
        J^F           =  J*O*U^2*D1,
        J^(F^-1)      =  J*O*Z,
        J^G           =  J*Q^-1*W*E1^2*F1,
        J^(G^-1)      =  J*Q*W^5*E1*S1,
        J^H           =  J*R*A1*H1*I1*K1,
        J^(H^-1)      =  J*R*H1*I1*N1,
        J^I           =  J*U^2*Z*D1,
        J^(I^-1)      =  J*U*Z,
        K^A           =  K,
        K^(A^-1)      =  K,
        K^B           =  K,
        K^(B^-1)      =  K,
        K^C           =  K,
        K^(C^-1)      =  K,
        K^D           =  K*N^-2*T*V^-1*X*G1*H1*K1^2*L1,
        K^(D^-1)      =  K*N^2*T^2*V^-1*X*C1^5*G1*H1*K1^2*L1^2*R1,
        K^E           =  K,
        K^(E^-1)      =  K,
        K^F           =  K,
        K^(F^-1)      =  K,
        K^G           =  K*T*G1,
        K^(G^-1)      =  K*T^2*C1^3*G1*P1^2*R1,
        K^H           =  K,
        K^(H^-1)      =  K,
        K^I           =  K,
        K^(I^-1)      =  K,
        K^J           =  K*A1^2*K1^2*N1,
        K^(J^-1)      =  K*A1*K1*N1,
        L^A           =  L*X*K1,
        L^(A^-1)      =  L*X,
        L^B           =  L*R*A1*K1*N1,
        L^(B^-1)      =  L*R*I1,
        L^C           =  L*N*H1*N1,
        L^(C^-1)      =  L*N^-1*T*H1*N1,
        L^D           =  L,
        L^(D^-1)      =  L,
        L^E           =  L*X*K1,
        L^(E^-1)      =  L*X,
        L^F           =  L*R*A1*K1*N1,
        L^(F^-1)      =  L*R*I1,
        L^G           =  L*V^-1*C1*P1^2*R1,
        L^(G^-1)      =  L*V*C1^5*P1,
        L^H           =  L*X*K1,
        L^(H^-1)      =  L*X,
        L^I           =  L*A1*I1*K1*N1,
        L^(I^-1)      =  L*A1^2*I1*K1^2*N1,
        L^J           =  L*H1*N1,
        L^(J^-1)      =  L*H1*N1,
        L^K           =  L*K1,
        L^(K^-1)      =  L*K1^2,
        M^A           =: M*N,
        M^(A^-1)      =  M*N^-1*G1,
        M^B           =: M*O,
        M^(B^-1)      =  M*O*U^2*Z*D1,
        M^C           =: M*P,
        M^(C^-1)      =  M*P^2*W^3*D1*F1*O1*S1,
        M^D           =: M*Q,
        M^(D^-1)      =  M*Q^-1*F1,
        M^E           =  M*R*H1*I1*N1,
        M^(E^-1)      =  M*R*A1*H1*I1*K1,
        M^F           =  M*S*U*Z*J1,
        M^(F^-1)      =  M*S*U^2*Z*B1^2*D1*O1,
        M^G           =  M*W^5*E1,
        M^(G^-1)      =  M*W*E1^2*S1,
        M^H           =  M*Y*A1^2*K1^2*N1,
        M^(H^-1)      =  M*Y*A1*K1*L1*N1,
        M^I           =  M*B1^2*J1*O1,
        M^(I^-1)      =  M*B1*J1,
        M^J           =  M,
        M^(J^-1)      =  M,
        M^K           =  M*L1,
        M^(K^-1)      =  M*L1^2,
        M^L           =  M*H1*N1,
        M^(L^-1)      =  M*H1*N1,
        N^A           =  N*G1,
        N^(A^-1)      =  N*G1,
        N^B           =: N*R,
        N^(B^-1)      =  N*R*A1*I1*K1*N1,
        N^C           =  N*T,
        N^(C^-1)      =  N*T^2*C1^3*R1,
        N^D           =  N*V,
        N^(D^-1)      =  N*V^-1*R1,
        N^E           =  N*X,
        N^(E^-1)      =  N*X*K1,
        N^F           =  N*Y*A1^2*I1*K1^2*N1,
        N^(F^-1)      =  N*Y*A1*I1*K1*L1*N1,
        N^G           =  N*C1^5*P1,
        N^(G^-1)      =  N*C1*P1^2,
        N^H           =  N*G1*K1^2,
        N^(H^-1)      =  N*G1*K1,
        N^I           =  N*L1,
        N^(I^-1)      =  N*L1^2,
        N^J           =  N*H1*N1,
        N^(J^-1)      =  N*H1*N1,
        O^A           =  O*X*A1^2*H1*K1^2,
        O^(A^-1)      =  O*X*A1*H1*K1,
        O^B           =  O*Z,
        O^(B^-1)      =  O*Z,
        O^C           =: O*S,
        O^(C^-1)      =  O*S*B1^2*M1^2,
        O^D           =  O,
        O^(D^-1)      =  O,
        O^E           =  O*I1,
        O^(E^-1)      =  O*I1,
        O^F           =  O*Z,
        O^(F^-1)      =  O*Z,
        O^G           =  O*D1*Q1,
        O^(G^-1)      =  O*D1*Q1^2,
        O^H           =  O*I1,
        O^(H^-1)      =  O*I1,
        O^I           =  O,
        O^(I^-1)      =  O,
        O^J           =  O,
        O^(J^-1)      =  O,
        P^A           =: P*T,
        P^(A^-1)      =  P*T^2*C1^3*R1,
        P^B           =: P*U,
        P^(B^-1)      =  P*U^2*D1,
        P^C           =  P*O1,
        P^(C^-1)      =  P*O1,
        P^D           =  P*W^2*F1*S1,
        P^(D^-1)      =  P*W^4*F1,
        P^E           =  P*A1^2*K1^2*N1,
        P^(E^-1)      =  P*A1*K1*N1,
        P^F           =  P*B1^2*O1,
        P^(F^-1)      =  P*B1,
        P^G           =  P*E1^2*S1,
        P^(G^-1)      =  P*E1,
        P^H           =  P*L1,
        P^(H^-1)      =  P*L1^2,
        P^I           =  P*M1^2,
        P^(I^-1)      =  P*M1,
        P^J           =  P,
        P^(J^-1)      =  P,
        Q^A           =: Q*V,
        Q^(A^-1)      =  Q*V^-1,
        Q^B           =  Q,
        Q^(B^-1)      =  Q,
        Q^C           =: Q*W,
        Q^(C^-1)      =  Q*W^5*E1*S1,
        Q^D           =  Q*F1,
        Q^(D^-1)      =  Q*F1^5,
        Q^E           =  Q,
        Q^(E^-1)      =  Q,
        Q^F           =  Q*D1*O1*Q1^2,
        Q^(F^-1)      =  Q*D1*O1*Q1,
        Q^G           =  Q*F1^5,
        Q^(G^-1)      =  Q*F1,
        Q^H           =  Q*N1,
        Q^(H^-1)      =  Q*N1,
        Q^I           =  Q*Q1^2,
        Q^(I^-1)      =  Q*Q1,
        Q^J           =  Q,
        Q^(J^-1)      =  Q,
        R^A           =: R*X,
        R^(A^-1)      =  R*X*K1,
        R^B           =  R*I1,
        R^(B^-1)      =  R*I1,
        R^C           =: R*Y,
        R^(C^-1)      =  R*Y*L1,
        R^D           =  R,
        R^(D^-1)      =  R,
        R^E           =  R,
        R^(E^-1)      =  R,
        R^F           =  R*I1,
        R^(F^-1)      =  R*I1,
        R^G           =  R*H1,
        R^(G^-1)      =  R*H1,
        S^A           =  S*G1*L1^2,
        S^(A^-1)      =  S*G1*L1,
        S^B           =: S*Z,
        S^(B^-1)      =  S*Z,
        S^C           =  S*M1^2*O1,
        S^(C^-1)      =  S*M1*O1,
        S^D           =  S*D1*O1*Q1^2,
        S^(D^-1)      =  S*D1*O1*Q1,
        S^E           =  S*I1,
        S^(E^-1)      =  S*I1,
        S^F           =  S*J1,
        S^(F^-1)      =  S*J1,
        S^G           =  S*O1,
        S^(G^-1)      =  S*O1,
        T^A           =  T,
        T^(A^-1)      =  T,
        T^B           =  T*A1^2*K1^2*N1,
        T^(B^-1)      =  T*A1*K1*N1,
        T^C           =  T,
        T^(C^-1)      =  T,
        T^D           =  T*C1^2*R1,
        T^(D^-1)      =  T*C1^4*R1,
        T^E           =  T*K1^2,
        T^(E^-1)      =  T*K1,
        T^F           =  T*L1,
        T^(F^-1)      =  T*L1^2,
        T^G           =  T*P1^2,
        T^(G^-1)      =  T*P1,
        U^A           =: U*A1,
        U^(A^-1)      =  U*A1^2*K1,
        U^B           =  U,
        U^(B^-1)      =  U,
        U^C           =: U*B1,
        U^(C^-1)      =  U*B1^2*M1*O1,
        U^D           =  U,
        U^(D^-1)      =  U,
        U^E           =  U,
        U^(E^-1)      =  U,
        U^F           =  U,
        U^(F^-1)      =  U,
        U^G           =  U*Q1^2,
        U^(G^-1)      =  U*Q1,
        V^A           =  V,
        V^(A^-1)      =  V,
        V^B           =  V,
        V^(B^-1)      =  V,
        V^C           =  V*C1,
        V^(C^-1)      =  V*C1^5*P1,
        V^D           =  V*R1,
        V^(D^-1)      =  V*R1^5,
        V^E           =  V,
        V^(E^-1)      =  V,
        V^F           =  V*N1,
        V^(F^-1)      =  V*N1,
        V^G           =  V*R1^5,
        V^(G^-1)      =  V*R1,
        W^A           =: W*C1,
        W^(A^-1)      =  W*C1^5,
        W^B           =: W*D1,
        W^(B^-1)      =  W*D1,
        W^C           =: W*E1,
        W^(C^-1)      =  W*E1^2*S1,
        W^D           =: W*F1,
        W^(D^-1)      =  W*F1^5,
        W^E           =  W*N1,
        W^(E^-1)      =  W*N1,
        W^F           =  W*O1*Q1,
        W^(F^-1)      =  W*O1*Q1^2,
        W^G           =  W*S1,
        W^(G^-1)      =  W*S1,
        X^A           =  X,
        X^(A^-1)      =  X,
        X^B           =  X,
        X^(B^-1)      =  X,
        X^C           =  X*G1,
        X^(C^-1)      =  X*G1,
        X^D           =  X,
        X^(D^-1)      =  X,
        Y^A           =: Y*G1,
        Y^(A^-1)      =  Y*G1,
        Y^B           =  Y*I1,
        Y^(B^-1)      =  Y*I1,
        Y^C           =  Y,
        Y^(C^-1)      =  Y,
        Y^D           =: Y*H1,
        Y^(D^-1)      =  Y*H1,
        Z^A           =: Z*I1,
        Z^(A^-1)      =  Z*I1,
        Z^B           =  Z,
        Z^(B^-1)      =  Z,
        Z^C           =: Z*J1,
        Z^(C^-1)      =  Z*J1,
        Z^D           =  Z,
        Z^(D^-1)      =  Z,
        A1^A           =: A1*K1,
        A1^(A^-1)      =  A1*K1^2,
        A1^B           =  A1,
        A1^(B^-1)      =  A1,
        A1^C           =  A1*L1,
        A1^(C^-1)      =  A1*L1^2,
        A1^D           =  A1,
        A1^(D^-1)      =  A1,
        B1^A           =: B1*L1,
        B1^(A^-1)      =  B1*L1^2,
        B1^B           =  B1,
        B1^(B^-1)      =  B1,
        B1^C           =: B1*M1,
        B1^(C^-1)      =  B1*M1^2,
        B1^D           =  B1*Q1,
        B1^(D^-1)      =  B1*Q1^2,
        C1^A           =  C1,
        C1^(A^-1)      =  C1,
        C1^B           =: C1*N1,
        C1^(B^-1)      =  C1*N1,
        C1^C           =  C1*P1,
        C1^(C^-1)      =  C1*P1^2,
        C1^D           =  C1*R1,
        C1^(D^-1)      =  C1*R1^5,
        D1^A           =  D1,
        D1^(A^-1)      =  D1,
        D1^B           =  D1,
        D1^(B^-1)      =  D1,
        D1^C           =: D1*O1,
        D1^(C^-1)      =  D1*O1,
        D1^D           =  D1,
        D1^(D^-1)      =  D1,
        E1^A           =: E1*P1,
        E1^(A^-1)      =  E1*P1^2,
        E1^B           =: E1*Q1,
        E1^(B^-1)      =  E1*Q1^2,
        E1^C           =  E1,
        E1^(C^-1)      =  E1,
        E1^D           =  E1,
        E1^(D^-1)      =  E1,
        F1^A           =: F1*R1,
        F1^(A^-1)      =  F1*R1^5,
        F1^B           =  F1,
        F1^(B^-1)      =  F1,
        F1^C           =: F1*S1,
        F1^(C^-1)      =  F1*S1,
        F1^D           =  F1,
        F1^(D^-1)      =  F1 >

#    Class : 8
#    Nr of generators of each class : 4 3 3 3 4 6 9 13

