## AUTO commands for the Specht package.
## Automatically generated Thu Nov  6 13:56:53 EST 2008
##                                        Andrew Mathas
##                            mathas@mathas.usyd.edu.au

# Combinatorial functions which use or interface with chevie
AUTO( ReadSpecht( "chevie" ),
  CompositionYoungSubgroupGenerators,
  CoxeterPermSymmPerm,
  CoxeterPermTableau,
  DistinguishedDoubleCosetRepresentatives,
  DistinguishedLeftCosetRepresentatives,
  DistinguishedRightCosetPermutations,
  DistinguishedRightCosetRepresentatives,
  Multicombinations,
  RowStandardTableauDoubleCosetRep,
  SymmPermCoxeterPerm,
  SymmPermCoxeterWord,
  YoungSubgroup
);

AUTO( ReadSpecht( "crystals" ),
  AmplitutdeMap,
  BasePartition,
  ConormalNodes,
  CrystalAmplitudeOps,
  CrystalWeightPartition,
  DownPartition,
  GoodNodeLatticePath,
  GoodNodeLatticePaths,
  GoodNodeSequence,
  GoodNodeSequences,
  GoodNodes,
  LadderNodeSequences,
  LatticePathGoodNodeSequence,
  NormalAndConormalNodes,
  NormalNodes,
  NormalNodesAbacusRunners,
  PartitionGoodNodeSequence,
  RemoveNormalNodes,
  RoofPartition,
  StronglyNormalNodes,
  TableauGoodNodeSequence,
  TauPartition,
  TopGoodNodeSequence,
  UpPartition,
  VeryGoodNodes,
  WeylGroupActionPartition
);

# Functions for manipulating decomposition matrices.
AUTO( ReadSpecht( "decomp" ),
  AddIndecomposable,
  AdjustmentMatrix,
  BlockCrystalizedDecompositionMatrix,
  BlockDecompositionMatrix,
  CalculateDecompositionMatrix,
  CanonicalLabelling,
  CartanDeterminant,
  CrystalizedDecompositionMatrix,
  DecompositionMatrixMatrix,
  DecompositionNumber,
  DecompositionNumberMultiplicityOne,
  DecompositionNumberRouquierBlock,
  DominatedDecompositionMatrix,
  EmptyCrystalizedDecompositionMatrix,
  EmptyDecompositionMatrix,
  FindAllCrystalizedDecompositionNumbers,
  FormalCharactersDecompositionMatrix,
  InducedDecompositionMatrix,
  InvertDecompositionMatrix,
  IsColumnMinimal,
  IsDecompositionMatrix,
  IsInRouquierBlock,
  IsNewIndecomposable,
  LinkageClassesDecompositionMatrix,
  MatrixDecompositionMatrix,
  MaximumsDecompositionMatrix,
  MissingIndecomposables,
  MultiplicityFreeBlockDecompositionMatrix,
  MultiplicityOneDecomposition,
  NormalLabels,
  Obstructions,
  QuotientLabels,
  RemoveIndecomposable,
  RestrictedBlockDecompositionMatrix,
  RichardsLabels,
  RouquierBlock,
  RowLimitedDecompositionMatrix,
  SSRestrictedModule,
  SaveDecompositionMatrix,
  SubmatrixDecompositionMatrix,
  WeightDecompositionMatrix,
  WeightTwoDecompositionMatrix
);

# Functions for inducing and restricting modules.
AUTO( ReadSpecht( "induce" ),
  InducedModule,
  InnerProduct,
  IntegralCoefficients,
  LabelByEQuotient,
  LabelMultiPartition,
  LabelPartition,
  LabelQuotient,
  PositiveCoefficients,
  RealLabelPartition,
  RestrictedModule,
  SInducedModule,
  SRestrictedModule,
  SmallLabelPartition,
  SpechtPrettyPrint,
  SpechtPrintFn,
  Specialized,
  StringPartition,
  TightLabelPartition,
  TightStringList,
  TightTeXQuotient
);

# Defines generic records for working with modules and with algebras
AUTO( ReadSpecht( "moduleElements" ),
  AlgebraOperations,
  AlgebraRecord,
  DimensionOfRadicalFromStructureConstants,
# IsAlgebraElement,
  IsCommutativeFromBasis,
  IsModuleElement,
  MakeAlgebraElement,
  MakeModuleElement,
  ModuleOperations,
  ModuleRecord,
  MultiplicationTableBasis,
  RewriteWithRespectToBasis,
  TriangularBasis
);

# Computes invariants relating to Richards' pyramids
AUTO( ReadSpecht( "pyramids" ),
  AbacusSymbolPartition,
  AdjacentPyramids,
  AllPyramids,
  AreAdjacentPyramids,
  CheckPyramidRestrictions,
  ConjugatePyramid,
  CorePyramid,
  CoreResiduesPyramid,
  CrystalizedDecompositionMatrixPyramid,
  Debug,
  DecompositionMatrixPyramid,
  DecompositionNumberWeightTwoPartitions,
  DeltaPartition,
  DominatesRichardsSymbols,
  ExceptionalColumnsDecompositionMatrix,
  ExceptionalPartitionsPyramids,
  FayersStrings,
  IsDirtyPartitionForPyramids,
  IsExceptionalPartitionForPyramids,
  IsPyramid,
  IsPyramidRegular,
  PartitionEAbacusSymbol,
  PartitionPyramid,
  PartitionPyramidQuotient,
  PartitionRichardsSymbol,
  PrintPyramidsByLevel,
  PyramidDecompositionMatricesByRestriction,
  PyramidOps,
  PyramidOrder,
  PyramidPartition,
  PyramidRestrictionGraph,
  PyramidsByLevel,
  RestrictingPyramids,
  RichardsLabelPartition,
  RichardsOrdering,
  RichardsSymbolPartition,
  RouquierPyramid,
  ScopesReducedPartition,
  SmallerAdjacentPyramids
);

# The heart of the SPECHT package: defines the Specht record structures
AUTO( ReadSpecht( "specht" ),
  ERegulars,
  IsSimpleModule,
  IsSpecht,
  LimitPartitionLength,
  ListERegulars,
  ProjectiveDimension,
  Schur,
  SimpleDimension,
  Specht,
  SpechtOps,
  SplitECores
);

# Combinatorial functions coming from symmetric groups and Hecke algebras
AUTO( ReadSpecht( "symmcomb" ),
  AddAllINodes,
  AddRimHook,
  AddableINodes,
  AddableNodes,
  BetaNumbers,
  CanonicalQuotient,
  CanonicalQuotientDominance,
  CanonicalQuotientLengthLexicographic,
  CombineCanonicalQuotientECore,
  CombineEQuotientECore,
  CompositionsOfLength,
  ConjugateMultiPartition,
  ConjugatePartition,
  CoxeterWordSymmPerm,
  CycleTypePermutation,
  CycleTypeTypeBWord,
  DonkinNormalFormPartition,
  DonkinNormalFormPartitionOps,
  EAbacus,
  EAbacusOperations,
  EAbacusRunners,
  ECore,
  EPowerDiagram,
  EQuotient,
  ERegularPartitions,
  ERegularPartitionsOfGivenWeight,
  ERegularizationPartition,
  EResidueDiagram,
  EResidueSequenceTableau,
  EResidueSequencesPartition,
  ERestrictedPartitions,
  EWeight,
  FrobeniusSymbolPartition,
  FullEAbacus,
  FullEAbacusRunners,
  FullEAbacuses,
  GeneratorsYoungSubgroupComposition,
  HookLengthDiagram,
  HookLengthsPartition,
  HookPartitions,
  IndexPolynomialComposition,
  IntegralGramDeterminant,
  InverseLittlewoodRichardsonRule,
  IsCarterPartition,
  IsContainedInPartitions,
  IsECore,
  IsERegular,
  IsERestrictedPartition,
  JMCharacter,
  JMCharacterSpechtModule,
  JMCharacterTableau,
  JantzenCoefficients,
  LabelCanonicalQuotient,
  LengthLexicographic,
  LengthLexicographicallyByQuotient,
  LengthReverseLexicographic,
  Lexicographic,
  LittlewoodRichardsonCoefficient,
  LittlewoodRichardsonRule,
  MullineuxMap,
  MullineuxSymbol,
  PPowerGramDeterminant,
  ParityPartition,
  PartitionAbacusRunners,
  PartitionBetaSet,
  PartitionMullineuxSymbol,
  PartitionsInSameBlock,
  PartitionsOfGivenWeight,
  PartitionsOfLength,
  PermutationCycleType,
  QuantumFactorial,
  QuantumInteger,
  QuotientOrder,
  RemovableINodes,
  RemovableNodes,
  RemoveAllINodes,
  RemoveNodeFromRow,
  RemoveRimHook,
  ReverseConjugateLexicographic,
  ReverseDominance,
  Schaper,
  SchaperMatrix,
  ScopesClassPartition,
  SpechtDimension,
  SwapRunnersDown,
  SymmPermSymmWord,
  SymmWordSymmPerm,
  TeXCanonicalQuotient,
  TeXQuotient
);

# Functions for generating and manipulating (semistandard) tableaux
AUTO( ReadSpecht( "tableaux" ),
  ActOnMultiTableau,
  ActOnTableau,
  AreLadderEquivalentTableaux,
  BumpTableau,
  BumpTableaux,
  BumpingTableau,
  ConjugateMultiTableau,
  ConjugateTableau,
  CoxeterWordTableau,
  DescentSetTableau,
  DominatesTableau,
  FirstSemistandardTableauType,
  FirstStandardTableau,
  FirstTableau,
  InitialSuperTableau,
  InitialTableau,
  IsComposition,
  IsMultiPartition,
  IsMultiStandardTableau,
  IsPartition,
  IsRowSemistandardTableau,
  IsRowStandardTableau,
  IsSemistandardTableau,
  IsStandardTableau,
  LadderClassTableau,
  LadderSequencePartition,
  LastSemistandard,
  LastSemistandardTableauType,
  LastTableau,
  MappingPermTableaux,
  MultiStandardTableaux,
  ResidueSequence,
  ReverseRobinsonSchenstedCorrespondent,
  RobinsonSchenstedCorrespondent,
  SemistandardFromStandard,
  SemistandardTableaux,
  ShapeTableau,
  StandardTableaux,
  StandardTableauxSemistandardTableau,
  StringTableau,
  Subtableau,
  SuperSemistandardFromStandard,
  SuperSemistandardtableaux,
  SymmPermTableau,
  TeXTableau,
  TypeTableau,
  TypedSemistandardTableaux,
  TypedSuperSemistandardTableaux,
  UnbumpTableaux,
  VeryTightMultiTableau,
  VeryTightStringList,
  VeryTightTableau
);

# Generic functions for producing TeX code for Gap elements
AUTO( ReadSpecht( "tex" ),
  AddToString,
  TeX,
  TeXMatrix,
  TeXPolynomial,
  TeXTop,
  TeXWideMatrix
);

AUTO( ReadSpecht( "tilt" ),
  ErdmannDecompositionMatrix,
  ErdmannDecompositionNumber,
  ErdmannPartitionMap
);

# Generic utility functions
AUTO( ReadSpecht( "util" ),
  DeleteListEntry,
  FactoredInteger,
  GoodString,
  IsProperSubset,
  PPower,
  ReplaceAllStrings,
  SaveRecord,
  SwapListEntries
);

# The "weight three calculator" from my small weight paper with Gordon
AUTO( ReadSpecht( "weight3" ),
  AbacusSymbol,
  AbacusSymbolOps,
  AddTrick,
  AddWeightThreeRows,
  AllWeightThreeCases,
  BlockComponent,
  CheckDimensions,
  CheckMullineuxMultiplicity,
  CheckRestrictionSequence,
  CheckRestrictions,
  CheckWeightThreeMatrixWithHeckeAlgebra,
  DominanceInterval,
  GenerateAllWeightThreeCases,
  InterpolatedPartition,
  IsAbacusSymbol,
  IsWeightThreeCalculator,
  KleshchevReduction,
  PartitionAbacusSymbol,
  PartitionDictionary,
  RecreateWeightThreeCalculator,
  RemoveLastWeightThreeRow,
  RewriteWeightThreeAsSimples,
  SchaperAbacusSymbol,
  ScopesReduction,
  SimpleModule,
  SimpleTwoRowedSpecht,
  TeXProblemCases,
  VeryGoodDecompositionNumber,
  WTCAbacusSymbolPartition,
  WeightThreeCalculator,
  WeightThreeCalculatorOps,
  WeightTwoAsSimples
);
